#include <bits/stdc++.h>
using namespace std;

#define int long long
#define forn(i,n) for(int i=0; i<n; ++i)
#define pi pair<int,int>
#define f first
#define s second
#define pb push_back

void solve() {
    
    int n; cin>>n;
    int f=0,s=0;
    int mx=0, rig=-1;
    //const int Z=1e6+5;
    map<int,int> cnt,type;
    vector<int> v;
    vector<pi> a,b;
    forn(i,n) {
        int x,m; cin>>x>>m;
        char c; cin>>c; int t = c=='R';
        if (t) f+=m;
        else s+=m;
        if (x > mx) {
            mx = x;
            rig = t;
        }
        type[x]=t;
        cnt[x]=m;
        v.push_back(x);
        if (t) a.pb({x,m});
        else b.pb({x,m});
    }
    if (f==s) {
        cout<<"Draw 0 0\n"; return;
    }
    if (f<s && rig==1) {
        cout<<"Draw "<<mx<<' '<<"+\n"; return;
    }
    if (s<f && rig==0) {
        if (cnt[mx]==1) {
            if (type[mx-1]==1) {
                cout<<"First "<<mx-1<<' '<<"+\n"; return;
            }
        }
        cout<<"Draw 0 0\n"; return;
    }
    sort(v.rbegin(),v.rend());
    sort(a.rbegin(),a.rend());
    sort(b.rbegin(),b.rend());
    if (f>s) {
        int i=0,j=0;
        int ok=1;
        int sum=0;
        while (i<a.size() && j<b.size()) {
            int z = min(a[i].s,b[j].s);
            sum+=z*(mx-a[i].f);
            sum-=z*(mx-b[j].f);
            a[i].s-=z;
            b[j].s-=z;
            if (a[i].s==0) ++i;
            if (b[j].s==0) ++j;
            if (sum>0) ok=0;
        }
        if (ok) {
            cout<<"First ";
            if (a.size()>1) cout<<a[1].f<<" +\n";
            else cout<<"0 0\n";
            return;
        }
        cout<<"Draw 0 0\n";
        return;
    }
    int i=0,j=0;
    int ok=1;
    int sum=0;
    while (i<a.size() && j<b.size()) {
        int z = min(a[i].s,b[j].s);
        sum-=z*(mx-a[i].f);
        sum+=z*(mx-b[j].f);
        a[i].s-=z;
        b[j].s-=z;
        if (a[i].s==0) ++i;
        if (b[j].s==0) ++j;
        if (sum>0) ok=0;
    }
    if (ok) {
        cout<<"Second\n";
        return;
    }
    cout<<"Draw 0 0\n";

}   

int32_t main() {
    int t; cin>>t;
    while (t--) solve();
}
